#pragma once
#include <luna/Result.h>

template <typename T, class... Args> [[nodiscard]] Result<T*> make(Args... args)
{
    T* const result = new T(args...);
    if (!result) return err(ENOMEM);
    return result;
}

template <typename T> [[nodiscard]] Result<T*> make_array(usize count)
{
    T* const result = new T[count];
    if (!result) return err(ENOMEM);
    return result;
}

template <typename T> void destroy(T* item)
{
    delete item;
}

template <typename T> void destroy_array(T* item)
{
    delete[] item;
}